package com.hai.dao;

import com.hai.entity.HighDiscountInventoryRecord;
import com.hai.entity.HighDiscountInventoryRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountInventoryRecordMapper extends HighDiscountInventoryRecordMapperExt {
    @SelectProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountInventoryRecordExample example);

    @DeleteProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountInventoryRecordExample example);

    @Delete({
        "delete from high_discount_inventory_record",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into high_discount_inventory_record (discount_package_title, discount_package_id, ",
        "now_stock_num, front_stock_num, ",
        "stock_num, company_id, ",
        "created_user_id, created_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{discountPackageTitle,jdbcType=VARCHAR}, #{discountPackageId,jdbcType=INTEGER}, ",
        "#{nowStockNum,jdbcType=INTEGER}, #{frontStockNum,jdbcType=INTEGER}, ",
        "#{stockNum,jdbcType=INTEGER}, #{companyId,jdbcType=INTEGER}, ",
        "#{createdUserId,jdbcType=INTEGER}, #{createdTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountInventoryRecord record);

    @InsertProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountInventoryRecord record);

    @SelectProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="discount_package_title", property="discountPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="now_stock_num", property="nowStockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="front_stock_num", property="frontStockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="stock_num", property="stockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountInventoryRecord> selectByExample(HighDiscountInventoryRecordExample example);

    @Select({
        "select",
        "id, discount_package_title, discount_package_id, now_stock_num, front_stock_num, ",
        "stock_num, company_id, created_user_id, created_time, `status`, ext_1, ext_2, ",
        "ext_3",
        "from high_discount_inventory_record",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="discount_package_title", property="discountPackageTitle", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.INTEGER),
        @Result(column="now_stock_num", property="nowStockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="front_stock_num", property="frontStockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="stock_num", property="stockNum", jdbcType=JdbcType.INTEGER),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_user_id", property="createdUserId", jdbcType=JdbcType.INTEGER),
        @Result(column="created_time", property="createdTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountInventoryRecord selectByPrimaryKey(Integer id);

    @UpdateProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountInventoryRecord record, @Param("example") HighDiscountInventoryRecordExample example);

    @UpdateProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountInventoryRecord record, @Param("example") HighDiscountInventoryRecordExample example);

    @UpdateProvider(type=HighDiscountInventoryRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountInventoryRecord record);

    @Update({
        "update high_discount_inventory_record",
        "set discount_package_title = #{discountPackageTitle,jdbcType=VARCHAR},",
          "discount_package_id = #{discountPackageId,jdbcType=INTEGER},",
          "now_stock_num = #{nowStockNum,jdbcType=INTEGER},",
          "front_stock_num = #{frontStockNum,jdbcType=INTEGER},",
          "stock_num = #{stockNum,jdbcType=INTEGER},",
          "company_id = #{companyId,jdbcType=INTEGER},",
          "created_user_id = #{createdUserId,jdbcType=INTEGER},",
          "created_time = #{createdTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(HighDiscountInventoryRecord record);
}